/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfrom.h"
#include "prog.h"

#line 1 "bi_other.m4"
/* This file is part of mailfrom filter.             -*- c -*-
   Copyright (C) 2006 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

static int
valid_user_p(eval_environ_t env, const char *name)
{
	int rc;
	struct mu_auth_data *auth_data = NULL;

#if HAVE_MU_GET_AUTH
	rc = mu_get_auth(&auth_data, mu_auth_key_name, name);
	mu_auth_data_free(auth_data);
	switch (rc) {
	case 0:
		rc = 1;
		break;
		
	case MU_ERR_AUTH_FAILURE:
		rc = 0;
		break;

	case EAGAIN:
		if (env_catch(env, mf_temp_failure) == 0)
			return;
		runtime_error(env,
			      "Temporary failure querying for username %s",
			      name);
		break;

	default:
		if (env_catch(env, mf_failure) == 0)
			return;
		runtime_error(env,
			      "Failure querying for username %s",
			      name);
		break;
	}
#else
	auth_data = mu_get_auth_by_name(name);
	rc = auth_data != NULL;
	mu_auth_data_free(auth_data);
#endif
	debug2(10, "Checking user %s: %s", name,
	       rc ? "true" : "false");
	return rc;
}

void
#line 63
bi_validuser(eval_environ_t env)
#line 63 "bi_other.m4"
{
#line 63
	char * name = (char *) get_arg(env, 0);
#line 63
        
#line 63
        adjust_stack(env, 1);
#line 63
	if (prog_trace_option)
#line 63
		prog_trace(env, "validuser %s",
#line 63
	                   name);
#line 63

{
	push(env, (STKVAL) valid_user_p(env, name));
}
}

void
#line 69
bi_interval(eval_environ_t env)
#line 69 "bi_other.m4"
{
#line 69
	char * str = (char *) get_arg(env, 0);
#line 69
        
#line 69
        adjust_stack(env, 1);
#line 69
	if (prog_trace_option)
#line 69
		prog_trace(env, "interval %s",
#line 69
	                   str);
#line 69

{
       time_t t;
       char *endp;

       if (parse_time_interval(str, &t, &endp)) {
	       if (env_catch(env, mf_invtime) == 0)
		       return;
               runtime_error(env,
                             "unrecognized time  (near `%s')",
                             endp);
       }
       push(env, (STKVAL) t);
}
}

void
#line 85
bi_rate(eval_environ_t env)
#line 85 "bi_other.m4"
{
#line 85
	char * key = (char *) get_arg(env, 1);
#line 85
        long  interval = (long ) get_arg(env, 0);
#line 85
        
#line 85
        adjust_stack(env, 2);
#line 85
	if (prog_trace_option)
#line 85
		prog_trace(env, "rate %s %lu",
#line 85
	                   key, interval);
#line 85

{
	double rate;
	long lrate;
		
	if (get_rate(key, &rate) != mf_success) {
		if (env_catch(env, mf_dbfailure) == 0)
			return;
		runtime_error(env, "cannot get rate for %s", key);
	}
	lrate = rate * interval;
	
	push(env, (STKVAL) lrate);
}
}


#line 101
void
#line 101
other_init_builtin()
#line 101
{
#line 101
	#line 63 "bi_other.m4"
va_builtin_install("validuser", bi_validuser, rettype_number, 1, rettype_string);
#line 69 "bi_other.m4"
va_builtin_install("interval", bi_interval, rettype_number, 1, rettype_string);
#line 85 "bi_other.m4"
va_builtin_install("rate", bi_rate, rettype_number, 2, rettype_string, rettype_number);

#line 101 "bi_other.m4"
		
#line 101
}
#line 0

#line 0

